/*    SNAKE is free software: you can redistribute it and/or modify
      it under the terms of the GNU General Public License as published by
      the Free Software Foundation, either version 3 of the License, or
      (at your option) any later version.

      SNAKE is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      GNU General Public License for more details.

      You should have received a copy of the GNU General Public License
      along with SNAKE.  If not, see <http://www.gnu.org/licenses/>.

____________________________________________________________________________________

     Author: Federico Salotti
     Organization/Company: Mr_Robot_Computers_Repair
     Country: Italy Barga(LU)
     Release: 0.1 (23 January 2019 02:07)

*/

class Snake
{
public:
	Snake()
	{
		this->_snake.push_back(sf::Vector2f(32,64));
		this->_snake.push_back(sf::Vector2f(16,64));
	}

	std::vector<sf::Vector2f> getPosition()
	{
		return this->_snake;
	}

	void setDirection(short direction)
	{
		this->_direction=direction;
	}

	short getDirection()
	{
		return this->_direction;
	}

	void move()
	{
		sf::Vector2f old_pos_head=this->_snake.at(0);
		sf::Vector2f old_pos;
		sf::Vector2f tmp_pos;

		if(this->_direction == 0)this->_snake.at(0).x+=CELL_W; //DX
		if(this->_direction == 1)this->_snake.at(0).x-=CELL_W; //SX
		if(this->_direction == 2)this->_snake.at(0).y-=CELL_W; //UP
		if(this->_direction == 3)this->_snake.at(0).y+=CELL_W; //DOWN

		for(auto part=this->_snake.begin()+1; part != this->_snake.end(); part++)
		{
			if(part == this->_snake.begin()+1)
			{
				old_pos=(*part);
				(*part)=old_pos_head;
			}

			else
			{
				tmp_pos=(*part);
				(*part)=old_pos;
				old_pos=tmp_pos;
			}
		}
	}

	void shrink()
	{
		this->_snake.resize(2);
	}

	void reset(int x, int y)
	{
		this->_snake.at(0).x=x;
		this->_snake.at(0).y=y;
	}

	bool check_collision()
	{
		sf::Vector2f headXY=this->_snake.at(0);

		for(auto part=this->_snake.begin()+1; part != this->_snake.end();  ++part)
			if((*part).x == headXY.x && (*part).y == headXY.y)
				return true;
			return false;
	}

	void grow()
	{
		if(this->_snake.size() < 100)
		{
			sf::Vector2f snake_part(this->_snake.back().x,this->_snake.back().y);
			this->_snake.push_back(snake_part);
		}

	}

private:
sf::Clock _chrono;
short _direction=0;
std::vector<sf::Vector2f> _snake;
};
